/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "push.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUM = 258
   };
#endif
#define NUM 258





/* Copy the first part of user declarations.  */
#line 3 "rpc.y"

#define YYSTYPE double
#define YYDEBUG 1
#include <math.h>
#include <stdio.h>
#include<stdlib.h>
	

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif




/* Copy the second part of user declarations.  */


/* Line 201 of yacc.c.  */
#line 101 "rpc.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = pv->yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   18

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  12
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  4
/* YYNRULES -- Number of rules. */
#define YYNRULES  13
/* YYNRULES -- Number of states. */
#define YYNSTATES  16

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   258

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     7,     5,     2,     6,     2,     8,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     9,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      10,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      11,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    12,    14,    18,    22,
      26,    30,    34,    37
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      13,     0,    -1,    -1,    13,    14,    -1,     4,    -1,    15,
       4,    -1,     3,    -1,    15,    15,     5,    -1,    15,    15,
       6,    -1,    15,    15,     7,    -1,    15,    15,     8,    -1,
      15,    15,     9,    -1,    15,    10,    -1,    11,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    15,    15,    16,    19,    20,    23,    24,    25,    26,
      27,    29,    31,    32
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUM", "'\\n'", "'+'", "'-'", "'*'", "'/'", 
  "'^'", "'n'", "'x'", "$accept", "input", "line", "exp", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,    10,    43,    45,    42,    47,    94,
     110,   120
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    12,    13,    13,    14,    14,    15,    15,    15,    15,
      15,    15,    15,    15
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     2,     1,     3,     3,     3,
       3,     3,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     6,     4,    13,     3,     0,     5,    12,
       0,     7,     8,     9,    10,    11
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     1,     6,    10
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3
static const yysigned_char yypact[] =
{
      -3,     0,    -3,    -3,    -3,    -3,    -3,    -2,    -3,    -3,
       7,    -3,    -3,    -3,    -3,    -3
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
      -3,    -3,    -3,     4
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
       2,     3,     8,     3,     4,     7,     0,     0,     9,     5,
       3,     5,    11,    12,    13,    14,    15,     9,     5
};

static const yysigned_char yycheck[] =
{
       0,     3,     4,     3,     4,     1,    -1,    -1,    10,    11,
       3,    11,     5,     6,     7,     8,     9,    10,    11
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    13,     0,     3,     4,    11,    14,    15,     4,    10,
      15,     5,     6,     7,     8,     9
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(pv->yyerrstatus = 0)
#define yyclearin	(pv->yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!pv->yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (pv->yychar == YYEMPTY && yylen == 1)				\
    {								\
      pv->yychar = (Token);						\
      uv->yylval = (Value);						\
      yytoken = YYTRANSLATE (pv->yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}





struct yyuvars {
	int instance;
	int yyresult;
	int token;
	YYSTYPE yylval;
        
};

#if defined (__STDC__) || defined (__cplusplus)
void yyerror (const char*);
#else
void yyerror ();
#endif

void* yypvarsinit(void);
struct yyuvars* yyuvarsinit(void);

# if defined (__STDC__) || defined (__cplusplus)
void yyparse (void *, struct yyuvars *);
#endif


struct yypvars{

  int yystate;
  int yyn;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss;
  short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs;
  YYSTYPE *yyvsp;

  

#define YYPOPSTACK   (pv->yyvsp--, pv->yyssp--)
  YYSIZE_T yystacksize;

  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  YYSTYPE yyval;
  int yylen;
  int yynerrs;
  int yychar;
int new;/* used to flag a new parser instance */
  };




/* Init the parser data structure. Use malloc, should perhaps use a 
system dependent equivalent function.
*/
void* 
yypvarsinit(void)
{
  struct yypvars *pv;
  pv= (struct yypvars *) malloc(sizeof(struct yypvars));
  pv->yytoken = 0;
  pv->yyss = pv->yyssa;
  pv->yyvs = pv->yyvsa;
  
  pv->yystacksize = YYINITDEPTH;
  pv->yystate = 0;
  pv->yyerrstatus = 0;
  pv->yynerrs = 0;
  pv->yychar = YYEMPTY;
  pv->yyssp = pv->yyss;
  pv->yyvsp = pv->yyvs;
pv->new= 1; /* this is a new instance */

  return (void*) pv;
}

static int yyinstancecounter= 0;
struct yyuvars* yyuvarsinit(void)
{
	struct yyuvars *uv;
	uv= (struct yyuvars*) malloc(sizeof(struct yyuvars));
        uv->yyresult= -1;
        uv->instance= ++yyinstancecounter;
	return uv;
}





#define GIVE_ME_TOKEN 4

/*----------.
| yyparse.  |
`----------*/

# if defined (__STDC__) || defined (__cplusplus)
void yyparse (void *, struct yyuvars *);
void yyparse (void * pvvoid, struct yyuvars *uv)
#else
void yyparse (y, u) /* ??? */
void *y, struct yyuvars *u;
#endif
{
  YYDPRINTF ((stderr, "Starting parse\n"));
  struct yypvars * pv= (struct yypvars*) pvvoid;

/* pv->new must be != 0 at the first call for each 
parser instance to properly set the parser going.
*/

  if (pv->new == 0) goto gottoken;
  pv->new= 0; 
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  pv->yyssp++;
  goto yysetstate;


 yysetstate:
  *pv->yyssp = pv->yystate;

  if (pv->yyss + pv->yystacksize - 1 <= pv->yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = pv->yyssp - pv->yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = pv->yyvs;
	short *yyss1 = pv->yyss;
]

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*pv->yyssp),
		    &yyvs1, yysize * sizeof (*pv->yyvsp),

		    &pv->yystacksize);

	pv->yyss = yyss1;
	pv->yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= pv->yystacksize)
	goto yyoverflowlab;
      pv->yystacksize *= 2;
      if (YYMAXDEPTH < pv->yystacksize)
	pv->yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = pv->yyss;
	short *yyss = yyss1;
	YYSTYPE *yyvs;
	YYSIZE_T yystacksize= pv->yystacksize;
        yystacksize++; /* to avoid compiler warning message */
        yystacksize--;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (pv->yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	yyss= pv->yyss;
	YYSTACK_RELOCATE (yyss);
	yyvs= pv->yyvs;
	YYSTACK_RELOCATE (yyvs);
	
#  undef YYSTACK_RELOCATE
	if (yyss1 != pv->yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      pv->yyssp = pv->yyss + yysize - 1;
      pv->yyvsp = pv->yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) pv->yystacksize));

      if (pv->yyss + pv->yystacksize - 1 <= pv->yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", pv->yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  pv->yyn = yypact[pv->yystate];
  if (pv->yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (pv->yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Returns for a new token: "));
      uv->yyresult= GIVE_ME_TOKEN;
      return;
gottoken:
      pv->yychar = uv->token;
      YYDPRINTF((stderr, "\nGot token %d", pv->yychar));
    }

  if (pv->yychar <= YYEOF)
    {
      pv->yychar = pv->yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      pv->yytoken = YYTRANSLATE (pv->yychar);
      YYDSYMPRINTF ("Next token is", pv->yytoken, &uv->yylval, &uv->yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  pv->yyn += pv->yytoken;
  if (pv->yyn < 0 || YYLAST < pv->yyn || yycheck[pv->yyn] != pv->yytoken)
    goto yydefault;
  pv->yyn = yytable[pv->yyn];
  if (pv->yyn <= 0)
    {
      if (pv->yyn == 0 || pv->yyn == YYTABLE_NINF)
	goto yyerrlab;
      pv->yyn = -pv->yyn;
      goto yyreduce;
    }

  if (pv->yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[pv->yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (pv->yychar != YYEOF)
    pv->yychar = YYEMPTY;

  *++(pv->yyvsp) = uv->yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (pv->yyerrstatus)
    pv->yyerrstatus--;

  pv->yystate = pv->yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  pv->yyn = yydefact[pv->yystate];
  if (pv->yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
  yyreduce:{
  YYSTYPE *yyvsp= pv->yyvsp;
  YYSTYPE yyval= pv->yyval;
  /* yyn is the number of a rule to reduce with.  */
  pv->yylen = yyr2[pv->yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  pv->yyval = pv->yyvsp[1-pv->yylen];


  YY_REDUCE_PRINT (pv->yyn);
  YYDPRINTF((stderr,"pv->yyvsp: %f %f %f", 
	     pv->yyvsp[0],pv->yyvsp[-1],pv->yyvsp[-2]));
  YYDPRINTF((stderr,"yyvsp: %f %f %f", 
	     yyvsp[0],yyvsp[-1],yyvsp[-2]));
	switch (pv->yyn)
		{
	    case 5:
#line 20 "rpc.y"
    { fprintf (stderr,"\nResult%d: \t%.10g", uv->instance,yyvsp[-1]); ;}
    break;

  case 6:
#line 23 "rpc.y"
    { yyval = yyvsp[0];           ;}
    break;

  case 7:
#line 24 "rpc.y"
    { yyval = yyvsp[-2] + yyvsp[-1];      ;}
    break;

  case 8:
#line 25 "rpc.y"
    { yyval = yyvsp[-2] - yyvsp[-1];      ;}
    break;

  case 9:
#line 26 "rpc.y"
    { yyval = yyvsp[-2] * yyvsp[-1];      ;}
    break;

  case 10:
#line 27 "rpc.y"
    { yyval = yyvsp[-2] / yyvsp[-1];      ;}
    break;

  case 11:
#line 29 "rpc.y"
    { yyval = pow (yyvsp[-2], yyvsp[-1]); ;}
    break;

  case 12:
#line 31 "rpc.y"
    { yyval = -yyvsp[-1];          ;}
    break;

  case 13:
#line 32 "rpc.y"
    {YYACCEPT;}
    break;


		  }
pv->yyval= yyval;
YYDPRINTF((stderr, "YYVAL= %f", yyval));
/* Line 1016 of yacc.c.  */
#line 1053 "rpc.tab.c"

  pv->yyvsp -= pv->yylen;
  pv->yyssp -= pv->yylen;


  YY_STACK_PRINT (pv->yyss, pv->yyssp);

  *(++pv->yyvsp) = pv->yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  pv->yyn = yyr1[pv->yyn];

  pv->yystate = yypgoto[pv->yyn - YYNTOKENS] + *pv->yyssp;
  if (0 <= pv->yystate && pv->yystate <= YYLAST && yycheck[pv->yystate] == *pv->yyssp)
    pv->yystate = yytable[pv->yystate];
  else
    pv->yystate = yydefgoto[pv->yyn - YYNTOKENS];
  }
  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!pv->yyerrstatus)
    {
      ++pv->yynerrs;
#if YYERROR_VERBOSE
      pv->yyn = yypact[pv->yystate];

      if (YYPACT_NINF < pv->yyn && pv->yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (pv->yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = pv->yyn < 0 ? -pv->yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + pv->yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = pv->yyn < 0 ? -pv->yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + pv->yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (pv->yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (pv->yychar == YYEOF)
        {
		short * yyssp= pv->yyssp;
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (pv->yyss < pv->yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], pv->yyvsp, pv->yylsp);
	      yydestruct (yystos[*yyssp], pv->yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", pv->yytoken, &uv->yylval, &uv->yylloc);
      yydestruct (pv->yytoken, &uv->yylval);
      pv->yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  pv->yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      pv->yyn = yypact[pv->yystate];
      if (pv->yyn != YYPACT_NINF)
	{
	  pv->yyn += YYTERROR;
	  if (0 <= pv->yyn && pv->yyn <= YYLAST && yycheck[pv->yyn] == YYTERROR)
	    {
	      pv->yyn = yytable[pv->yyn];
	      if (0 < pv->yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (pv->yyssp == pv->yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*pv->yyssp], pv->yyvsp, pv->yylsp);
      yydestruct (yystos[pv->yystate], pv->yyvsp);
      pv->yyvsp--;
      pv->yystate = *--pv->yyssp;

      YY_STACK_PRINT (pv->yyss, pv->yyssp);
    }

  if (pv->yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++pv->yyvsp = uv->yylval;


  pv->yystate = pv->yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  uv->yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  uv->yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  uv->yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (pv->yyss != pv->yyssa)
    YYSTACK_FREE (pv->yyss);
#endif
  return;
}


#line 32 "rpc.y"


